/*
  Copyright Eric Reese, 2005
  This code is part of KLBDT and is distributed under the GNU GPL, version 2 or
  (at your option) any later version as published by the Free Software Foundation.
  This comes with no warranty whatsoever, without even the implied warranty of
  merchantability or fitness for a particular purpose.  It might not even work.
  See the GNU GPL for more details. http://www.gnu.org/licenses/gpl.txt

  http://kyzentun.tejat.net/contact.html lists ways of contacting me.
 */
#ifndef DRAW_HH
#define DRAW_HH

#include "SDL.h"

#include "error.hh"
#include "point.hh"

void set_screen_geometry(int width, int height);
/* Note:  Only has effect if called before init_drawing() is called. */
void init_drawing() throw(error);
void reset_drawing();

void update_drawn_rects();
void frequency_update_drawn_rects(int fi);

void draw_pixel(point pos, Uint32 color, bool hilight);
void draw_unzoomed_rect(point upper_left, point width_and_height, Uint32 color);
void black_screen();
Uint32 color_at_point(point p);

Uint32 interpolate(Uint32 s_color, Uint32 c_color, Uint32 e_color, int line_length);
/* Needs function, just an empty function right now. */
unsigned int increase_zoom();
unsigned int decrease_zoom();
void set_zoom(unsigned int new_zoom);
point get_screen_offset();
int move_horizontally(int amount);
int move_vertically(int amount);
void set_background_color(Uint32 new_color);
Uint32 get_background_color();

#define DEFAULT_WIDTH 1600
#define DEFAULT_HEIGHT 1200

extern SDL_Surface* screen;
extern bool procrastinate_drawing;
extern unsigned int critical_update_area_mass;
extern int update_frequency;

#endif
