/*
  Copyright Eric Reese, 2005
  This code is part of KLBDT and is distributed under the GNU GPL, version 2 or
  (at your option) any later version as published by the Free Software Foundation.
  This comes with no warranty whatsoever, without even the implied warranty of
  merchantability or fitness for a particular purpose.  It might not even work.
  See the GNU GPL for more details. http://www.gnu.org/licenses/gpl.txt

  http://kyzentun.tejat.net/contact.html lists ways of contacting me.
 */
#ifndef OP_ENV_HH
#define OP_ENV_HH

#include <list>
#include <string>

#include "happy_list.hh"

struct op_env
{
  void init();

  void next_list();
  void previous_list();
  void first_list();
  void last_list();
  void indexed_list(int index);
  void mung();
  void add_op_to_current_list(int op);
  void pop_back_current_list();
  void add_new_list();
  void save_op_list(std::string file_name, std::list<int>& src) throw(error);
  void save_current_op_list(std::string file_name) throw(error);
  void save_all_op_lists(std::string& fn_prefix, std::string& fn_suffix) throw(error);

private:
  happy_list<std::list<int> > op_lists;
};

#endif
