/*
  Copyright Eric Reese, 2005
  This code is part of KLBDT and is distributed under the GNU GPL, version 2 or
  (at your option) any later version as published by the Free Software Foundation.
  This comes with no warranty whatsoever, without even the implied warranty of
  merchantability or fitness for a particular purpose.  It might not even work.
  See the GNU GPL for more details. http://www.gnu.org/licenses/gpl.txt

  http://kyzentun.tejat.net/contact.html lists ways of contacting me.
 */
#include "point.hh"
/*
point operator=(point rhs)
  {
    x= rhs.x;
    y= rhs.y;
    return *this;
  }
*/
point point::operator=(int rhs)
  {
    x= rhs;
    y= rhs;
    return *this;
  }

point operator+(point lhs, point rhs)
  {
    return point(lhs.x + rhs.x, lhs.y + rhs.y);
  }

point operator+(point lhs, int rhs)
  {
    return point(lhs.x + rhs, lhs.y + rhs);
  }

point operator-(point lhs, point rhs)
  {
    return point(lhs.x - rhs.x, lhs.y - rhs.y);
  }

point operator-(point lhs, int rhs)
  {
    return point(lhs.x - rhs, lhs.y - rhs);
  }

point operator/(point lhs, int rhs)
  {
    return point(lhs.x / rhs, lhs.y / rhs);
  }

point operator*(point lhs, int rhs)
  {
    return point(lhs.x * rhs, lhs.y * rhs);
  }

point operator+=(point& lhs, point rhs)
  {
    return lhs= lhs + rhs;
  }

point operator+=(point& lhs, int rhs)
  {
    return lhs= lhs + rhs;
  }

point operator-=(point& lhs, point rhs)
  {
    return lhs= lhs - rhs;
  }

point operator-=(point& lhs, int rhs)
  {
    return lhs= lhs - rhs;
  }

point operator*=(point& lhs, int rhs)
  {
    return lhs= lhs * rhs;
  }

point operator/=(point& lhs, int rhs)
  {
    return lhs= lhs / rhs;
  }

bool operator<(point lhs, point rhs)
  {
    if(lhs.y == rhs.y)
    {
      return lhs.x < rhs.x;
    }
    return lhs.y < rhs.y;
  }

bool operator>(point lhs, point rhs)
  {
    if(lhs.y == rhs.y)
    {
      return lhs.x > rhs.x;
    }
    return lhs.y > rhs.y;
  }

bool operator==(point lhs, point rhs)
  {
    return (lhs.x == rhs.x) && (lhs.y == rhs.y);
  }

bool operator!=(point lhs, point rhs)
  {
    return !(lhs == rhs);
  }
