/*
  Copyright Eric Reese, 2005
  This code is part of KLBDT and is distributed under the GNU GPL, version 2 or
  (at your option) any later version as published by the Free Software Foundation.
  This comes with no warranty whatsoever, without even the implied warranty of
  merchantability or fitness for a particular purpose.  It might not even work.
  See the GNU GPL for more details. http://www.gnu.org/licenses/gpl.txt

  http://kyzentun.tejat.net/contact.html lists ways of contacting me.
 */
#ifndef POINT_HH
#define POINT_HH

struct point
{
  point()
    :x(0), y(0)
  {}
  point(int px, int py)
    :x(px), y(py)
  {}
  int x, y;
  //  point operator=(point rhs); 
  point operator=(int rhs); /* No private members, but this must be a member anyway.
                               O_o */
};

point operator+(point lhs, point rhs);
point operator+(point lhs, int rhs);
point operator-(point lhs, point rhs);
point operator-(point lhs, int rhs);
point operator/(point lhs, int rhs);
point operator*(point lhs, int rhs);
point operator+=(point& lhs, point rhs);
point operator+=(point& lhs, int rhs);
point operator-=(point& lhs, point rhs);
point operator-=(point& lhs, int rhs);
point operator*=(point& lhs, int rhs);
point operator/=(point& lhs, int rhs);
bool operator<(point lhs, point rhs);
bool operator>(point lhs, point rhs);
bool operator==(point lhs, point rhs);
bool operator!=(point lhs, point rhs);

#endif
