/*
  Copyright Eric Reese, 2005
  This code is part of KLBDT and is distributed under the GNU GPL, version 2 or
  (at your option) any later version as published by the Free Software Foundation.
  This comes with no warranty whatsoever, without even the implied warranty of
  merchantability or fitness for a particular purpose.  It might not even work.
  See the GNU GPL for more details. http://www.gnu.org/licenses/gpl.txt

  http://kyzentun.tejat.net/contact.html lists ways of contacting me.
 */
#ifndef STR_TOOLS_HH
#define STR_TOOLS_HH

#include <string>
#include "SDL.h"

#include "error.hh"

bool match_strings(std::string shortest_match, std::string longest_match
  , std::string const& culprit);
bool str_to_bool(std::string const& str);
int str_to_int(std::string const& str) throw(error);
Uint32 str_to_uint32(std::string const& str) throw(error);
std::string int_to_hex_str(Uint32 i);
Uint32 hex_str_to_uint32(std::string const& str);
void operate_on_bool(std::string const& op_str, bool& patient);
size_t normalize_index(int index, size_t max_val) throw(error);

#endif
