/*
  Copyright Eric Reese, 2005
  This code is a stubroutine finder and is distributed under the GNU GPL, version 2 or
  (at your option) any later version as published by the Free Software Foundation.
  This comes with no warranty whatsoever, without even the implied warranty of
  merchantability or fitness for a particular purpose.  It might not even work.
  See the GNU GPL for more details. http://www.gnu.org/licenses/gpl.txt

  http://kyzentun.tejat.net/contact.html lists ways of contacting me.
 */
#include <iostream>
#include <fstream>
#include <string>
#include <vector>

using std::cin;
using std::cout;
using std::endl;
using std::ifstream;
using std::string;
using std::vector;

void process_file(string fn)
  {
    int stubroutine_match_level= 0;
    string s;
    int line_num= 0;
    vector<int> stubroutine_ends;
    ifstream in_file(fn.c_str());
    while(getline(in_file, s))
    {
      ++line_num;
      switch(stubroutine_match_level)
      {
        case 0:
          if(s[s.size()-1] == '{' || s[s.size()-1] == '}')
          ++stubroutine_match_level;
          break;
        case 1:
          if(s.empty() || s[s.size()-1] == ' ')
          ++stubroutine_match_level;
          else
          stubroutine_match_level= 0;
          break;
        case 2:
          if(s[s.size()-1] == '}' || s[s.size()-1] == '{')
          stubroutine_ends.push_back(line_num);
          stubroutine_match_level= 0;
          break;
      }
    }
    if(!stubroutine_ends.empty())
    {
      for(vector<int>::iterator n= stubroutine_ends.begin(); n != stubroutine_ends.end(); ++n)
      {
        cout << fn << ':' << *n << ": warning: expected code in subroutine" << endl;
      }
    }
  }

int main(int argc, char** argv)
  {
    for(int n= 1; n < argc; ++n)
    {
      process_file(argv[n]);
    }
    return 0;
  }
